/* strumslide -- a very simple X/motif demo of RTcmix
 *
 * uses the "STRUM" instrument with real-time controil bwah ha ha!
 * it reads little frames from a file, and the amount skipped into
 * the file is controlled by the slider.
 *
 * BGG
*/

#include <Xm/Xm.h>
#include <Xm/Scale.h>
#include <Xm/BulletinB.h>

#include <stdio.h>

#include "/musr/cmix/H/RTsockfuncs.h"

Widget topLevel;
Widget slider1,slider2,slider3,slider4;
Widget bboard;

int theSock;
int RTpid;


XtAppContext app;

main(int argc, char *argv[])
{
	void changeval1();
	void changeval2();
	void changeval3();
	void changeval4();



        /* start up the instrument */
        RTpid = RTopensocket(0, "./MYSTRUM/STRUM -c");
        sleep(3); /* allow the process time to start */

	/* open up the socket */
        theSock = RTsock("localhost", 0);

	/* set up the instrument */
	RTsendsock("rtsetparams", theSock, 3, 44100.0, 2.0, 256.0);
/*
	RTsendsock("print_off", theSock, 0);
// p0 = start; p1 = dur; p2 = pitch (oct.pc); p3 = fundamental decay time
// p4 = nyquist decay time; p5 = distortion gain; p6 = feedback gain
// p7 = feedback pitch (oct.pc); p8 = clean signal level
// p9 = distortion signal level; p10 = amp; p11 = squish
// p12 = stereo spread [optional]
// p13 = flag for deleting pluck arrays (used by FRET, BEND, etc.) [optional]
*/

	sleep(2);
	RTsendsock("START1", theSock, 13, 0.0, 99.0, 7.03, 99.0, 99.0, 0.0000001, 0.00001, 7.03, 0.0, 1.0, 1.0, 1.0, 0.5);



	topLevel=XtVaAppInitialize(&app,"strumslide",
			NULL,0,&argc,argv,NULL,NULL);

/* set up the main window */
        bboard = XtVaCreateManagedWidget("bboard",
                xmBulletinBoardWidgetClass, topLevel,
                XmNwidth, 700, XmNheight, 250, NULL);

/* set up the sliders YAY TEAM!*/
        slider1 = XtVaCreateManagedWidget("slider1",
                xmScaleWidgetClass, bboard,
                XmNx, 100, XmNy, 30, 
                XmNorientation, XmHORIZONTAL,
                XmNmaximum, 100, XmNscaleWidth, 500,
                XmNscaleHeight, 40, NULL);
	XtAddCallback(slider1, XmNdragCallback, changeval1, NULL);

        slider2 = XtVaCreateManagedWidget("slider2",
                xmScaleWidgetClass, bboard,
                XmNx, 100, XmNy, 80, 
                XmNorientation, XmHORIZONTAL,
                XmNmaximum, 100, XmNscaleWidth, 500,
                XmNscaleHeight, 40, NULL);
	XtAddCallback(slider2, XmNdragCallback, changeval2, NULL);
	
        slider3 = XtVaCreateManagedWidget("slider3",
                xmScaleWidgetClass, bboard,
                XmNx, 100, XmNy, 130, 
                XmNorientation, XmHORIZONTAL,
                XmNmaximum, 100, XmNscaleWidth, 500,
                XmNscaleHeight, 40, NULL);
	XtAddCallback(slider3, XmNdragCallback, changeval3, NULL);

        slider4 = XtVaCreateManagedWidget("slider4",
                xmScaleWidgetClass, bboard,
                XmNx, 100, XmNy, 180, 
                XmNorientation, XmHORIZONTAL,
                XmNmaximum, 100, XmNscaleWidth, 500,
                XmNscaleHeight, 40, NULL);
	XtAddCallback(slider4, XmNdragCallback, changeval4, NULL);

	XtManageChild(bboard);
	XtRealizeWidget(topLevel);
	XtAppMainLoop(app);
}


void changeval1(w, client, call)
Widget w;
XtPointer client, call;
{
	int ival;
	XmScaleGetValue(slider1, &ival);

	RTsendsock("rtupdate", theSock, 3, 1.0, 5.0, (float)ival/1000.0);

printf("slider1: %d\n",ival);

}

void changeval2(w, client, call)
Widget w;
XtPointer client, call;
{
	int ival;
	XmScaleGetValue(slider2, &ival);

	RTsendsock("rtupdate", theSock, 3, 1.0, 6.0, (float)ival);
printf("slider2: %d\n",ival);

}
void changeval3(w, client, call)
Widget w;
XtPointer client, call;
{
	int ival;
	XmScaleGetValue(slider3, &ival);

	RTsendsock("rtupdate", theSock, 3, 1.0, 10.0, (float)(ival*100));
printf("slider3: %d\n",ival);

}
void changeval4(w, client, call)
Widget w;
XtPointer client, call;
{
	int ival;
	XmScaleGetValue(slider4, &ival);

	RTsendsock("rtupdate", theSock, 3, 1.0, 2.0, (float)ival+100.0);
printf("slider4: %d\n",ival);

}
